package com.example.blum.horse_xml;

import android.content.res.XmlResourceParser;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import java.lang.reflect.Field;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

import java.util.ArrayList;
import java.util.List;

public class MainActivity extends AppCompatActivity {

    List<Horse> myList = new ArrayList<Horse>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        final TextView tvSire = (TextView) findViewById(R.id.tvSire);
        final TextView tvTrainer = (TextView) findViewById(R.id.tvTrainer);
        final ImageView ivSilks = (ImageView) findViewById(R.id.ivSilks);

        try{

            List<String> horsenames = new ArrayList<String>();

            XmlPullParser parser = getResources().getXml(R.xml.horseracing);
            int eventType=-1;
            int myIndex=-1;

            while(eventType!= XmlResourceParser.END_DOCUMENT){
                if(eventType==XmlResourceParser.START_TAG){
                    String tagName = parser.getName();
                    //Toast.makeText(getBaseContext(), tagName, Toast.LENGTH_LONG).show();
                    if(tagName.equals("element")){
                        myList.add(new Horse());
                        myIndex++;
                    }
                    else{
                        parser.next();  //move to text
                        //((Horse) myList.get(myIndex)).trainer = parser.getText();
                        try {
                            Field f1 = myList.get(myIndex).getClass().getField(tagName);
                            //Toast.makeText(getBaseContext(), ""+f1.getType(), Toast.LENGTH_LONG).show();
                            if((""+f1.getType()).equals("int")){
                                f1.set(myList.get(myIndex), Integer.parseInt(parser.getText()));
                            }
                            else if((""+f1.getType()).equals("double")){
                                f1.set(myList.get(myIndex), Double.parseDouble(parser.getText()));
                                //Toast.makeText(getBaseContext(), "here double", Toast.LENGTH_LONG).show();
                            }
                            else{

                                f1.set(myList.get(myIndex), parser.getText());
                            }


                            //Toast.makeText(getBaseContext(), parser.getText(), Toast.LENGTH_LONG).show();
                            parser.next();   //move to end tag
                        }catch(Exception e){
                            // tags like root and horses end up here -- not field names
                        }

                    }

                }
                eventType = parser.next();
            }

            //create simple array for Spinner
            for(Horse item : myList){
                System.out.println(item);
                horsenames.add(item.horseName);
            }

            //associate the full name with the listView
            Spinner spHorse = (Spinner) findViewById(R.id.spHorse);


            ArrayAdapter<String> aaHorse = new ArrayAdapter<String>(this,   android.R.layout.simple_spinner_item, horsenames);
            aaHorse.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
            spHorse.setAdapter(aaHorse);

            spHorse.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
                @Override
                public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                    tvSire.setText( myList.get(i).horseSire );
                    tvTrainer.setText(myList.get(i).horseTrainer);

                    int iv_id = getResources().getIdentifier(myList.get(i).horseSilks, "drawable",
                            getPackageName());
                    ivSilks.setImageResource(iv_id);
                }

                @Override
                public void onNothingSelected(AdapterView<?> adapterView) {

                }
            });


        }
        catch(XmlPullParserException e){
            Toast.makeText(getBaseContext(), "Problem XML parsing problem", Toast.LENGTH_LONG).show();
        }
        catch(Exception e){
            Toast.makeText(getBaseContext(), "Problem with file", Toast.LENGTH_LONG).show();
            e.printStackTrace();
        }

    }//end onCreate
}//end MainActivity

